climatedemo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
# from histo.views import main
from django.views.generic import TemplateView

from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('climap/', include('climap.urls')),
    path('stats/', include('stats.urls')),
    path('proj/', include('proj.urls')),
    path('favicon.ico',
        RedirectView.as_view( # the redirecting function
            url=staticfiles_storage.url('img/favicon.ico'), # converts the static directory + our favicon into a URL
        ),
        name="favicon" # name of our view
    ),
    path('', TemplateView.as_view(template_name='proj/main.html'), name='main'),
]

# if not settings.DOCKER:
#     urlpatterns.insert(0, path('climap/', include('climap.urls')))

histo/urls.py
from django.urls import path

from . import views

app_name = 'histo'

urlpatterns = [
    path('station/<int:sid>', views.index, name='station'),
    path('', views.index, name='index'),
    ]

proj/urls.py
from django.urls import path, register_converter
from django.views.generic import TemplateView
from . import views
from .export import image
from .netcdf import write_netcdf
from .maintenance import print_zd, del_zd, del_mrd, print_sp, del_sp, display_station_proj, print_param, del_param, listings

app_name = 'proj'

class Extension:
    regex = '[a-z]{2,3}'

    def to_python(self, value):
        return str(value)

    to_url = to_python

register_converter(Extension, 'xxx')

urlpatterns = [
    # static
    path('about', views.about, name='about'),
    path('help', views.help, name='help'),
    path('formula', views.formula, name='formula'),
    path('download', views.download, name='download'),
    path('faq', TemplateView.as_view(template_name='proj/faq.html'), name='faq'),

    path ('downparam/<pr>_<scen>_<zone>.csv', views.param_download, name='param_download'),
    path('downmetric/<met>_<scen>_<model>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<met>_<scen>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<metric>_<scen>_<model>.nc', write_netcdf, name='netcdf'),
    path('downzone/<met>_<scen>_<zone>.csv', views.zone_metric_download, name='zone_download'),

    # json / export
    path('<update>.json', views.jsoner, name='jsoner'),
    path('<period>.csv', views.csv_export, name='csv'),
    path('<period>.xls', views.xls_export, name='xls'),
    path('export.<xxx:extension>', image, name='plt'),

    # language toggle
    path('lang/<l>', views.lang, name='lang'),

    # main page
    path('simple', views.simple, name='simple'),
    path('', views.index, name='index'),

    # admin
    path('listings', listings, name='listings'),
    path('mod_zd', print_zd, name='print_zd'),
    path('mod_param', print_param, name='print_param'),
    path('mod_sp', print_sp, name='print_sp'),
    path('stations', display_station_proj, name='display_station'),
    path('del_zd/<mid>/<modname>/<scen>', del_zd, name='del_zd_scen'),
    path('del_zd/<mid>/<modname>', del_zd, name='del_zd'),
    path('del_param/<pid>/<modname>/<scen>', del_param, name='del_param_scen'),
    path('del_param/<pid>/<modname>', del_param, name='del_param'),
    path('del_mrd/<mid>/<modname>/<scen>', del_mrd, name='del_mrd_scen'),
    path('del_mrd/<mid>/<modname>', del_mrd, name='del_mrd'),
    path('del_sp/<modname>/<pid>/<sid>/<scen>', del_sp, name='del_sp_scen'),
    path('del_sp/<modname>/<pid>/<sid>/', del_sp, name='del_sp'),
    ]

stats/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required
from django.contrib.auth.views import LoginView
from django.views.generic import TemplateView

from . import views
app_name = 'stats'

urlpatterns = [
    path('login', LoginView.as_view(), name='login'),
    path('doc', TemplateView.as_view(template_name='stats/doc.html'), name='doc'),
    path('metric/<ip>', views.proj_metric, name='metric_by_ip'),
    path('metric', views.proj_metric, name='metric'),
    path('metriccsv', views.proj_metric_csv, name='metric_csv'),
    path('comments', login_required(views.CommentListView.as_view()), name='comments'),
    path('commentwrite', views.CommentCreate.as_view(), name='commentwrite'),
    path('commentdel/<int:pk>', login_required(views.CommentDelete.as_view()), name='commentdel'),
    path('', views.index, name='index'),
]

histo/models.py
from django.contrib.gis.db import models
from django.contrib.gis.geos import Point
from datetime import date
from proj.models import NamedModel, Parameter

class HParameter(NamedModel):
    AGG_TYPES = ('sum', 'max', 'min', 'avg')
    agg = models.CharField(choices=zip(AGG_TYPES, AGG_TYPES),
                           verbose_name='Formule d\'aggrégation', max_length=3, default='sum')
    FREQUENCIES = (('hour', 'heure'), ('day', 'jour'))
    freq = models.CharField(choices=FREQUENCIES, max_length=4, default='day', verbose_name='Fréquence')
    twoval = models.BooleanField(blank=True, default=False, verbose_name='Paramètre à deux valeurs',
                                 help_text="exemple : vent (intensité, direction)")
    color = models.CharField(max_length=10)
    shortname = models.CharField(max_length=10)
    # alias
    season_start = models.CharField(max_length=5, default='01-01', help_text='month-day')
    season_end = models.CharField(max_length=5, default='12-31', help_text='month-day')

    @property
    def shortname(self):
        """Alias"""
        return self.shortname

class Station(NamedModel):
    alt = models.IntegerField(null=True, verbose_name='altitude' ,default=0)
    STATION_TYPES = (('synoptic', 'synoptique'), ('climatic', 'climatique'), ('pluvio', 'pluviomètre'),)
    type = models.CharField(choices=STATION_TYPES, max_length=12, default='pluvio')
    coords = models.PointField(blank=True, null=True)
    lon = models.FloatField(blank=True, null=True)
    lat = models.FloatField(blank=True, null=True)

    def stationproj_ordered(self):
        return self.stationproj_set.select_related('param').order_by('param__id')

    def params(self):
        pass

    def save(self, *args, **kwargs):
        if self.lon and self.lat:
            self.coords = Point(self.lon, self.lat)
        else:
            self.lon, self.lat = self.coords.coords
        super(Station, self).save(*args, **kwargs)

class StationProj(models.Model):
    """Replacement for StationData"""
    file = models.FilePathField(verbose_name='HDF5 storage file')
    station = models.ForeignKey(Station, on_delete=models.CASCADE)
    param = models.ForeignKey(Parameter, on_delete=models.CASCADE)

    def read_rcp(self, key):
        return pd.read_hdf(self.file, key)
    # alias
    read_data = read_rcp

    def list_rcp(self):
        with pd.HDFStore(self.file, 'r') as store:
            return map(lambda x:x[1:], store) # remove '/' prefix



# TODO : get rid of all the following


def hdf5_path(instance, filename):
    return 'hdf5/{}/{}'.format(instance.param.name, '_'.join(instance.station.name.split()) + '.h5')


import pandas as pd
from django.conf import settings
NCDIR = settings.NCDIR
# minimum size of historical data for correction
MIN_CDFT_DATA_LEN = 365 * 10


# PARAM SPECIFIC INFOS

MIN_RAIN_DAY = 3 # mm
NORMAL_PERIOD = (1981, 2000) # must be string !

class StationInfo(models.Model):
    class Meta:
        ordering = ['-last_updated']

    station = models.ForeignKey(Station, on_delete=models.CASCADE)
    param = models.ForeignKey(HParameter, on_delete=models.CASCADE)
    last_updated = models.DateField(null=True)

    def __str__(self):
        return '{} {}'.format(self.station, self.param)

    def delta_last_updated(self):
        today = date.today()
        return (today-self.last_updated).days


class ParamSpecificInfo(models.Model):
    class Meta:
        abstract = True
        ordering = ['period']

    stinfo = models.ForeignKey(StationInfo, on_delete=models.CASCADE)
    PERIOD = (('M', 'dernier mois'), ('M3', '3 derniers mois'), ('Y', 'saison'), ('Z', 'normale saison'))
    period = models.CharField(choices=PERIOD, default='M', max_length=4, help_text="normale : {}-{}".format(*NORMAL_PERIOD))
    period_start = models.DateField(null=True)
    period_end = models.DateField(null=True)

    # percentiles
    p99 = models.IntegerField()
    p95 = models.IntegerField()

    def print_period(self):
        if self.period == 'Z':
            return "moyenne {}-{}".format(self.period_start.strftime('%Y'), self.period_end.strftime('%Y'))
        return "{}-{}".format(self.period_start.strftime('%d/%m'),self.period_end.strftime('%d/%m'))

    def __str__(self):
        return '{}, {}'.format(self.stinfo, self.period)

class StationRainInfo(ParamSpecificInfo):
    cumul = models.FloatField()
    daymax = models.FloatField()
    nbdays = models.IntegerField()
    # cumulative dry/wet days
    cdd = models.IntegerField(null=True)
    cwd = models.IntegerField(null=True)

class StationTempInfo(ParamSpecificInfo):
    daymax = models.FloatField()
    daymin = models.FloatField()
    dayavg = models.FloatField()

histo/views.py
from django.shortcuts import render, reverse
from django.http import HttpResponse, JsonResponse, Http404, HttpResponseRedirect
from . import models as hm
import pandas as pd
import numpy as np
from django.core.serializers import serialize
from re import split
from proj.models import Place
import json

from proj.models import ClimateModel
from proj.views import DYGRAPH_STROKE
from stats.decorators import count_histo_request

# Create your views here.
# import the logging library
import logging

# Get an instance of a logger
logger = logging.getLogger(__name__)


def base(request):
    return HttpResponseRedirect(reverse('proj:index'))


def main(request):
    return render(request, 'histo/main.html')

@count_histo_request
def index(request, sid=-1):
    COLORS = {'histo': {"color": "black", "strokeWidth": 2, "strokeBorderWidth": 1},
              'rcp85': {"color": "red", "strokeWidth": 2},
              'rcp45': {"color": "#6da5ff", "strokeWidth": 2},
              'rcp26': {"color": "blue", "strokeWidth": 2}}
    COLORS.update({s.name: {'id': s.id, 'color': s.color, 'strokePattern': DYGRAPH_STROKE.get(s.style, [])}
                   for s in ClimateModel.objects.all()})

    stations = hm.Station.objects.all()

    context = {
        # 'user': request.user.is_authenticated,
        'stations' : serialize('geojson', stations),
        'station_names': json.dumps([ st.name for st in stations ]),
        'places': serialize('geojson', Place.objects.filter(show=True)),
        'colors': json.dumps({ p.name : { 'color': p.color} for p in hm.HParameter.objects.all() }),
        'cdft_colors': json.dumps(COLORS)
    }
    if sid and sid >= 0:
        context['station'] = hm.Station.objects.get(id=sid)
        # context['normal_period'] = m.NORMAL_PERIOD

    return render(request, 'histo/index.html', context=context)

histo/templates/histo/base.html
<!doctype html>
<html lang="en">
<head>
    {% load static %}
    {% block scripts %}{% endblock %}
    <link rel="icon" href="{% static 'img/favicon.ico' %}">
    <link rel="stylesheet" href="{% static 'style.css' %}" type="text/css">
    <link rel="stylesheet" href="{% static 'respstyle.css'%}" type="text/css">

    <title>Géoportail Sénégal - Observations</title>
</head>
<body>
<div id="head" style="height:50px">
    <h2><a href="{% url 'main' %}">Géoportail Sénégal</a> - Observations</h2>
    {% block headinfo %}{% endblock %}
    <div class="links">
        {% block links %}{% endblock %}
    </div>

</div>

{% block content %}{% endblock %}

</body>
</html>

histo/templates/histo/index.html
{% extends 'histo/base.html' %}
{% block scripts %}
{% load static %}
<!--
<script src="{% static 'dygraph.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'dygraph.css' %}" type="text/css">
-->
<link rel="stylesheet" href="{% static 'ol.css'%}" type="text/css">
<script src="{% static 'ol.js' %}"></script>

<!-- autocomplete stuff -->
<link rel="stylesheet" href="{% static 'autocomplete.css'%}" type="text/css">
<script src="{% static 'autocomplete.js' %}"></script>
{% endblock %}
{% block content %}

<div class="smallpage">
    <div>
        <span style="color:red;">station climatique</span>
        <br><span style="color:green;">synoptique</span>
        <br><span style="color:blue;">pluviomètre</span>
    </div>
    <div id="map" style="height:500px; border:1px solid black"></div>
    <form autocomplete="off">
        <div class="autocomplete" style="width:300px;">
            <input id="find_station" type="text" name="myCountry" placeholder="find station">
        </div>
    </form>

    <script src="{% static 'stations.js' %}"></script>
    <script src="{% static 'histo.js' %}"></script>
    <script type="text/javascript">
var places = new ol.layer.Vector({
	source: new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures({{ places|safe }}),
            projection: 'EPSG:4326',
	}),
	zIndex: 6,
	style: textStyle
    });
map.addLayer(places);

var stationFeats = {{ stations|safe }};

var stations = new ol.layer.Vector({
	source: new ol.source.Vector({
            features: (new ol.format.GeoJSON()).readFeatures(stationFeats),
            projection: 'EPSG:4326'
	}),
	style: stationStyle,
	zIndex: 3
    });
map.addLayer(stations);

selectFeature = new ol.interaction.Select({
    condition: ol.events.condition.click,
    layers: [stations]
});

selectFeature.on('select', clickStation);
map.addInteraction(selectFeature);

var hover = new ol.interaction.Select({
    condition: ol.events.condition.pointerMove,
    style: stationHoverStyle,
    layers: [stations]
});
map.addInteraction(hover);

var background = new ol.layer.Vector({
    source: new ol.source.Vector({
        format: new ol.format.GeoJSON(),
        url: "{% static 'senegal.geojson' %}"
    }),
    style: new ol.style.Style({
        stroke: new ol.style.Stroke({ color: 'black' }),
        fill : new ol.style.Fill({ color: 'rgb(200,200,200)' })
    })
})
map.addLayer(background);

var series_color = {{ colors|safe }};
var cdft_color = {{ cdft_colors|safe }};


/* autocomplete */
var station_names = {{ station_names|safe }};
autocomplete(document.getElementById("find_station"), station_names);

var thisUrl = "{% url 'histo:index' %}";
</script>

{% if station %}

<div id="station">

    <h1>{{ station.name }} <a href="#head"><img src="{% static 'img/arrow-up-circle.svg' %}"></a></h1>

    <h3>Station {{ station.get_type_display }}</h3>
    <p>
        <i>longitude {{ station.lon }}, latitude {{ station.lat }}
            {% if station.alt %} / altitude : {{ station.alt }}m{% endif %}</i>
        <br>Voir les <a href="{% url 'proj:index' %}?station={{ station.pk }}">projections climatiques liées à cette
        station</a> (1950-2100).
    </p>

    {% for si in station.stationinfo_set.all %}
    <h2>{{ si.param }}</h2>
    {% if si.last_updated %}<p>dernière mise à jour : {{ si.last_updated }}
        (il y a {{ si.delta_last_updated }} jours)</p>{% endif %}

        {% if si.param.shortparam == 'pr' %}
        <table class="stationinfo">
            <tr>
                <th></th><th>cumul</th><th>max journalier</th><th>nb jours de pluie</th>
                <th>max jours<br>consécutifs de pluie<br>(CWD)</th><th>max jours<br>consécutifs sans pluie<br>(CDD)</th>
                <th>nb jours<br>>99e percentile</th><th>nb jours<br>>95e percentile</th>
            </tr>
            {% for i in si.stationraininfo_set.all %}
            <tr>
                <td>{{ i.get_period_display }} <br><span style="color:grey">{{ i.print_period }}</span></td>
                <td>{{ i.cumul }}mm</td><td>{{ i.daymax }}mm</td><td>{{ i.nbdays }}j</td>
                <td>{% if i.cwd != Null %}{{ i.cwd }}j{% endif %}</td><td>{% if i.cdd != Null %}{{ i.cdd }}j{% endif %}</td>
                <td>{{ i.p99 }}j</td><td>{{ i.p95 }}j</td>
            </tr>
            {% endfor %}
        </table>
        {% else %}
        <table class="stationinfo">
            <tr>
                <th></th><th>min</th><th>moyenne</th><th>max</th>
                <th>nb jours<br>>99e percentile</th><th>nb jours<br>>95e percentile</th>
            </tr>
            {% for i in si.stationtempinfo_set.all %}
            <tr>
                <td>{{ i.get_period_display }}
                    <br><span style="color:grey">{% if i.period == 'Y' %}
                        {{ i.period_end.year }}{% else %}{{ i.print_period }}{% endif %}</span>
                </td>
                <td>{{ i.daymin }}°C</td><td>{{ i.dayavg }}°C</td><td>{{ i.daymax }}°C</td>
                <td>{{ i.p99 }}j</td><td>{{ i.p95 }}j</td>
            </tr>
            {% endfor %}
        </table>
        {% endif %}
    {% endfor %}

    <p><a href="#head"><img src="{% static 'img/arrow-up-circle.svg' %}"></a></p>

</div>
{% endif %}
</div>

{% endblock %}

histo/templates/histo/main.html
<!doctype html>
<html lang="en">
<head>
    {% load static %}
    {% block scripts %}{% endblock %}
    <link rel="icon" href="{% static 'img/favicon.ico' %}">
    <link rel="stylesheet" href="{% static 'style.css' %}" type="text/css">
    <link rel="stylesheet" href="{% static 'respstyle.css'%}" type="text/css">

    <title>Géoportail Sénégal</title>
</head>
<body>
<div id="head" style="height:50px">
    <h2><a href="{% url 'main' %}">Géoportail Sénégal</a></h2>
    {% block headinfo %}{% endblock %}
    <div class="links">
        {% block links %}{% endblock %}
        {% if request.user.is_authenticated %}
        <a href="{% url 'main' %}">home</a> &middot;
        <a href="../admin">django admin</a> &middot;
        <a href="{% url 'stats:comments' %}">comments</a> &middot;
        <a href="{% url 'stats:metric' %}">metrics</a> &middot;
        {% else %}
        <a href="{% url 'stats:index' %}">login</a>
        {% endif %}
    </div>

</div>

<div class="smallpage">

    <h2><a href="{% url 'histo:index' %}">observations</a></h2>
    <p style="margin:20px">Stations météorologiques du Sénégal.<span style="color:red"> (en construction)</span></p>
    {% comment %}
    <h2><a>prévisions</a></h2>
    <p style="margin:20px">Prévisions météo par région. <span style="color:red">(en construction)</span></p>
    {% endcomment %}
    <h2><a href="{% url 'proj:index' %}">projections</a></h2>
    <p style="margin:20px">Projections climatiques à long terme par région.</p>

    <p style="margin-top:40px">Vous pouvez également
        <a href="{% url 'stats:commentwrite' %}">faire un commentaire sur le site</a>.</p>
</div>
</body>
</html>

<!--

-->

histo/templates/histo/uploadcsv.html
{% extends 'histo/base.html' %}
{% block content %}
    <div class="smallpage">
        <p class="helptext"><a href="{% url 'admin:index' %}histo/station">retour aux stations</a></p>
    <p style="width:800px">Charge un fichier csv de données journalières dont les colonnes sont de la forme (date, valeur).
        La date doit être sous un format standard du type 'YYYY-MM-DD' ou 'YYYY-MM-DD-HH'. La première ligne du fichier est ignorée.</p>
    <form action="{% url 'histo:loadcsv' %}#results" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        <ul>{{ form }}</ul>
        <input type="submit" value="Charger" onclick="this.disabled=true;"/>
    </form>
    </div>
{% endblock %}